Bug Hunting Session
Bug 112849 - Kashida characters appears at particular zoom levels (310%)
Summary: Kashida characters appears at particular zoom levels (310%)
Status: NEW
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Writer (show other bugs)
Version:
(earliest affected)
5.4.0.0.alpha0+
Hardware: All All
: medium normal
Assignee: Not Assigned
URL:
Whiteboard:
Keywords: bibisected, bisected, implementationError
Depends on: 104921
Blocks: Font-Rendering RTL-Arabic
  Show dependency treegraph
 
Reported: 2017-10-02 20:15 UTC by Yousuf Philips (jay) (retired)
Modified: 2019-02-19 03:43 UTC (History)
3 users (show)

See Also:
Crash report or crash signature:


Attachments
kashidas appear in red and period in green disappears (182.00 KB, image/png)
2017-10-02 20:15 UTC, Yousuf Philips (jay) (retired)
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Yousuf Philips (jay) (retired) 2017-10-02 20:15:01 UTC
Created attachment 136712 [details]
kashidas appear in red and period in green disappears

steps
1. open attachment 132839 [details]
2. zoom in to 310 percent and notice kashida's appearing in various places and notice periods disappearing

regression as this doesnt happen in 5.3.7.

Version: 6.0.0.0.alpha0+
Build ID: a2a3e06a29077d4274dc15eea28a01afe22e3658
CPU threads: 2; OS: Linux 4.4; UI render: default; VCL: gtk2; 
Locale: en-US (en_US.UTF-8); Calc: group
Comment 1 Xisco Faulí 2017-10-02 21:43:16 UTC
Regression introduced by:

author	Miklos Vajna <vmiklos@collabora.co.uk>	2017-03-30 07:27:45 (GMT)
committer	Miklos Vajna <vmiklos@collabora.co.uk>	2017-03-30 10:19:02 (GMT)
commit	38b0c24fa5cbb4246e03d77ac022dfdc9fdede03 (patch)
tree	6c500a9f343126a28508aaa2adc581d819a2eb96
parent	a82627aa787e80c9473453acd5ec955b6cf265ff (diff)
Related: tdf#105454 DOCX import: fix unwanted enabled-by-default kerning
Similar to DOC, DOCX doesn't enable kerning by default.

Bisected with: bibisect-linux-64-5.4

Adding Cc: to Miklos Vajna
Comment 2 Miklos Vajna 2017-10-03 07:46:03 UTC
I would argue this worked only by accident before. See bug 105454, DOC/DOCX does not enable kerning by default, enabling it by default for those documents in Writer was a bug that caused real problems.

If this change causes problems for Kashida, then it's just a coincidence that it worked previously. Somebody who understands complex text layout should find out how Word manages to handle that without kerning and based on that what we could do to improve the situation.

What do you think? I'm OK with looking at this at some stage, but I think "real" regressions are a priority.
Comment 3 Yousuf Philips (jay) (retired) 2017-10-03 16:20:09 UTC
Lets ask Khaled as he knows best about CTL and font rendering.
Comment 4 Khaled Hosny 2017-10-03 18:12:39 UTC
Kashida in LibreOffice is fundamentally broken:

// A note on how Kashida justification is implemented (because it took me 5
// years to figure it out):
// The decision to insert Kashidas, where and how much is taken by Writer.
// This decision is communicated to us in a very indirect way; by increasing
// the width of the character after which Kashidas should be inserted by the
// desired amount.
//
// Writer eventually calls IsKashidaPosValid() to check whether it can insert a
// Kashida between two characters or not.
//
// Here we do:
// - In LayoutText() set KashidaJustification flag based on text script.
// - In ApplyDXArray():
//   * Check the above flag to decide whether to insert Kashidas or not.
//   * For any RTL glyph that has DX adjustment, insert enough Kashidas to
//     fill in the added space.

from https://gerrit.libreoffice.org/gitweb?p=core.git;a=blob;f=vcl/source/gdi/CommonSalLayout.cxx;h=8e8565717932088558ee7a4b31fc0bfe405e98e3;hb=HEAD#l698

The insanity described above together with the the whole DX array madness and the use of integers to hold glyph positions, makes is so that any rounding errors would cause VCL to think that writer wants to insert a kashida in this place.

Fixing kashida once and for all requires 1) making the communication between Writer and VCL explicit e.g. have a separate “kashida insertion points” array 2) Kill DX array for good and enter the 21 century (it is an API “inspired” by Windows 3.1 3) Fix rounding errors by preserving fractional glyph positions in a way or another.
Comment 5 Miklos Vajna 2017-10-04 07:58:18 UTC
Thanks for the input, Khaled. None of the stuff you mention is introduced by the above commit, so let me re-tag this from regression to implementationError.
Comment 6 QA Administrators 2019-02-19 03:43:20 UTC
** Please read this message in its entirety before responding **

To make sure we're focusing on the bugs that affect our users today, LibreOffice QA is asking bug reporters and confirmers to retest open, confirmed bugs which have not been touched for over a year.

There have been thousands of bug fixes and commits since anyone checked on this bug report. During that time, it's possible that the bug has been fixed, or the details of the problem have changed. We'd really appreciate your help in getting confirmation that the bug is still present.

If you have time, please do the following:

Test to see if the bug is still present with the latest version of LibreOffice from https://www.libreoffice.org/download/

If the bug is present, please leave a comment that includes the information from Help - About LibreOffice.
 
If the bug is NOT present, please set the bug's Status field to RESOLVED-WORKSFORME and leave a comment that includes the information from Help - About LibreOffice.

Please DO NOT

Update the version field
Reply via email (please reply directly on the bug tracker)
Set the bug's Status field to RESOLVED - FIXED (this status has a particular meaning that is not 
appropriate in this case)


If you want to do more to help you can test to see if your issue is a REGRESSION. To do so:
1. Download and install oldest version of LibreOffice (usually 3.3 unless your bug pertains to a feature added after 3.3) from http://downloadarchive.documentfoundation.org/libreoffice/old/

2. Test your bug
3. Leave a comment with your results.
4a. If the bug was present with 3.3 - set version to 'inherited from OOo';
4b. If the bug was not present in 3.3 - add 'regression' to keyword


Feel free to come ask questions or to say hello in our QA chat: https://kiwiirc.com/nextclient/irc.freenode.net/#libreoffice-qa

Thank you for helping us make LibreOffice even better for everyone!

Warm Regards,
QA Team

MassPing-UntouchedBug